package com.tzld.piaoquan.recommend.server.service.score4recall.strategy;

import com.tzld.piaoquan.recommend.server.service.score.ScorerConfigInfo;
import com.tzld.piaoquan.recommend.server.service.score4recall.AbstractScorer4Recall;
import com.tzld.piaoquan.recommend.server.service.score4recall.model4recall.Model4RecallKeyValue;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.Pair;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author sunxy
 */
public class AppFallbackScorer extends AbstractScorer4Recall {

    public AppFallbackScorer(ScorerConfigInfo configInfo) {
        super(configInfo);
    }

    @Override
    public void loadModel() {
        doLoadModel(Model4RecallKeyValue.class);
    }

    @Override
    public List<Pair<Long, Double>> recall(Map<String, String> params) {
        Model4RecallKeyValue model = (Model4RecallKeyValue) this.getModel();
        if (model == null || model.kv == null) {
            return new ArrayList<>();
        }
        String city = params.get("region_code");
        List<Pair<Long, Double>> cityList;
        if (StringUtils.isBlank(city)
                || StringUtils.contains(city, "110100")
                || StringUtils.contains(city, "430100")) {
            cityList = model.kv.getOrDefault("北京长沙", new ArrayList<>());
        } else {
            cityList = model.kv.getOrDefault("非北京长沙", new ArrayList<>());
        }
        return cityList;
    }
}
